/*
    look@seti -
    Copyright (C) 1999 Jrgen Hochwald <hochwald@kde.org>
	
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.
			
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
					
    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/    

#ifndef _TOPLEVEL_H_
#define _TOPLEVEL_H_

#include <stdio.h>
#include <kapp.h>
#include <ktopwidget.h>
#include <kmenubar.h>
#include <kstatusbar.h>
#include <ktoolbar.h>
#include <kfiledialog.h>
#include <krestrictedline.h>
#include <kspinbox.h>
#include <qpopupmenu.h>
#include <qaccel.h>
#include <qwindow.h>
#include <qpainter.h>
#include <qfile.h>
#include <qdatetime.h>
#include <qpushbutton.h>
#include <qimage.h>
#include "chart.h"

class TopLevel : public KTopLevelWidget
{
  Q_OBJECT
  
public:

  TopLevel(const char *name=0);
  ~TopLevel();
  KStatusBar *statusbar;

protected:

   void setupMenuBar();
   void setupStatusBar();
   void setupToolBar();
   void keyPressEvent( QKeyEvent * );  

private slots:
  void aboutApp();

public:

   //TChart* Chart;
private:
   KMenuBar *menubar;
   KToolBar *toolbar;
   QPopupMenu *fileMenu, *optionsMenu, *helpMenu, *editMenu, *viewMenu;
   int modifyID, newID;
};

#endif
